---
product: "AG Grid"
title: "Column State"
description: "Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change)."
framework: javascript
version: "36.2.0"
related:
    - title: "Column Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-definitions/"
    - title: "Updating Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-updating-definitions/"
    - title: "Auto-Generate Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/auto-generate-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column State

Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change).

> **Note**
>
> The DOM also has stateful vs non-stateful attributes. For example consider a DOM element and setting `element.style.width="100px"` will indefinitely set width to 100 pixels, the browser will not change this value. However setting `element.scrollTop=200` will set the scroll position, but the browser can change the scroll position further following user interaction, thus scroll position is stateful as the browser can change the state.

The full list of stateful attributes of Columns are represented by the `ColumnStateParams` interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `hide` | `boolean \| null` |  |  |  |
| `width` | `number \| null` |  |  |  |
| `flex` | `number \| null` |  |  |  |
| `sort` | `SortDirection` |  |  |  |
| `sortType` | `SortType \| null` |  |  |  |
| `sortIndex` | `number \| null` |  |  |  |
| `aggFunc` | `string \| IAggFunc \| null` |  |  |  |
| `valueIndex` | `number \| null` |  |  |  |
| `pivot` | `boolean \| null` |  |  |  |
| `pivotIndex` | `number \| null` |  |  |  |
| `pivotSort` | `SortDirection` |  |  |  |
| `pinned` | `ColumnPinnedType` |  |  |  |
| `rowGroup` | `boolean \| null` |  |  |  |
| `rowGroupIndex` | `number \| null` |  |  |  |
| `showValuesAs` | `ShowValuesAsStateValue` |  |  |  |
| `headerName` | `string \| null` |  |  |  |

This section details how such state items can be manipulated without having to update Column Definitions.

## Save and Apply State

> **Note**
>
> If you want to save and restore the whole grid rather than manipulate individual column attributes, consider [Grid State](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/) instead. It contains all of the Column State properties alongside the other grid state sections — including [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/calculated-columns/) added at runtime, which Column State alone cannot recreate — and can be applied on initialisation via `initialState` or at runtime via `api.setState()`.

There are two API methods provided for getting and setting Column State. `api.getColumnState()` gets the current column state and `api.applyColumnState(params)` sets the column state.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnState` | `Function` |  |  |  |
| `applyColumnState` | `Function` |  |  |  |
| `resetColumnState` | `Function` |  |  |  |

The example below demonstrates saving and restoring column state. Try the following:

1. Click 'Save State' to save the Column State.
2. Change some column state, e.g. resize columns, move columns around, apply column sorting or row grouping, or rename an [editable header](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-headers/#editable-header-name) from its column menu, etc.
3. Click 'Restore State' and the column state is set back to where it was when you clicked 'Save State'.
4. Click 'Reset State' and the state will go back to what was defined in the Column Definitions.

#### Save and Apply State

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnHeaderEditModule,
  ColumnMenuModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

declare let window: any;

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnHeaderEditModule,
  ColumnMenuModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete", headerNameEditable: true },
  { field: "age", headerNameEditable: true },
  { field: "country", headerNameEditable: true },
  { field: "sport" },
  { field: "year" },
  { field: "date" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 100,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: {
    toolPanels: ["columns"],
  },
  rowGroupPanelShow: "always",
  pivotPanelShow: "always",
  // debug: true,
  columnDefs: columnDefs,
};

function saveState() {
  window.colState = gridApi!.getColumnState();
  console.log("column state saved");
}

function restoreState() {
  if (!window.colState) {
    console.log("no columns state to restore by, you must save state first");
    return;
  }
  gridApi!.applyColumnState({
    state: window.colState,
    applyOrder: true,
  });
  console.log("column state restored");
}

function resetState() {
  gridApi!.resetColumnState();
  console.log("column state reset");
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).saveState = saveState;
  (<any>window).restoreState = restoreState;
  (<any>window).resetState = resetState;
}
```

[Live example: Save and Apply State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/save-apply-state/typescript/)

## Partial State

It is possible to focus on particular columns and / or particular attributes when getting and / or applying a Column State. This allows fine grained control over the Column State, e.g. setting what Columns are Pinned, without impacting any other state attribute.

### Applying Partial State

When applying a Column State, in cases where some state attributes or columns are missing from the Column State, the following rules apply:

- Attributes that are not supplied or are set to `undefined` will remain unchanged. For example if a Column has a Column State with just `pinned`, then Pinned is applied to that Column but other attributes, such as `sort` are left intact.
- When state is applied and there are additional Columns in the grid that do not appear in the provided state, then the `params.defaultState` is applied to those additional Columns.
- If `params.defaultState` is not provided, then any additional Columns in the grid will not be updated.

Combining these rules together allows flexible fine-grained state control. Take the following code snippets as examples:

```js
// Sort Athlete column ascending
api.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ]
});

// Sort Athlete column ascending and clear sort on all other columns
api.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ],
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting on all columns, leave all other attributes untouched
api.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting, row group, pivot and pinned on all columns, leave all other attributes untouched
api.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null,
        rowGroup: null,
        pivot: null,
        pinned: null
    }
});

// Order columns, but do nothing else
api.applyColumnState({
    state: [
        { colId: 'athlete' },
        { colId: 'country' },
        { colId: 'age' },
        { colId: 'sport' }
    ],
    applyOrder: true
});
```

The example below shows some fine grained access to Column State.

#### Fine Grained State

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete" },
  { field: "age" },
  { field: "country" },
  { field: "sport" },
  { field: "year" },
  { field: "date" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 150,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: {
    toolPanels: ["columns"],
  },
  rowGroupPanelShow: "always",
  pivotPanelShow: "always",
  // debug: true,
  columnDefs: columnDefs,
};

function onBtSortAthlete() {
  gridApi!.applyColumnState({
    state: [{ colId: "athlete", sort: "asc" }],
  });
}

function onBtSortCountryThenSportClearOthers() {
  gridApi!.applyColumnState({
    state: [
      { colId: "country", sort: "asc", sortIndex: 0 },
      { colId: "sport", sort: "asc", sortIndex: 1 },
    ],
    defaultState: { sort: null },
  });
}

function onBtClearAllSorting() {
  gridApi!.applyColumnState({
    defaultState: { sort: null },
  });
}

function onBtRowGroupCountryThenSport() {
  gridApi!.applyColumnState({
    state: [
      { colId: "country", rowGroupIndex: 0 },
      { colId: "sport", rowGroupIndex: 1 },
    ],
    defaultState: { rowGroup: false },
  });
}

function onBtRemoveCountryRowGroup() {
  gridApi!.applyColumnState({
    state: [{ colId: "country", rowGroup: false }],
  });
}

function onBtClearAllRowGroups() {
  gridApi!.applyColumnState({
    defaultState: { rowGroup: false },
  });
}

function onBtOrderColsMedalsFirst() {
  gridApi!.applyColumnState({
    state: [
      { colId: "gold" },
      { colId: "silver" },
      { colId: "bronze" },
      { colId: "total" },
      { colId: "athlete" },
      { colId: "age" },
      { colId: "country" },
      { colId: "sport" },
      { colId: "year" },
      { colId: "date" },
    ],
    applyOrder: true,
  });
}

function onBtOrderColsMedalsLast() {
  gridApi!.applyColumnState({
    state: [
      { colId: "athlete" },
      { colId: "age" },
      { colId: "country" },
      { colId: "sport" },
      { colId: "year" },
      { colId: "date" },
      { colId: "gold" },
      { colId: "silver" },
      { colId: "bronze" },
      { colId: "total" },
    ],
    applyOrder: true,
  });
}

function onBtHideMedals() {
  gridApi!.applyColumnState({
    state: [
      { colId: "gold", hide: true },
      { colId: "silver", hide: true },
      { colId: "bronze", hide: true },
      { colId: "total", hide: true },
    ],
  });
}

function onBtShowMedals() {
  gridApi!.applyColumnState({
    state: [
      { colId: "gold", hide: false },
      { colId: "silver", hide: false },
      { colId: "bronze", hide: false },
      { colId: "total", hide: false },
    ],
  });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtSortAthlete = onBtSortAthlete;
  (<any>window).onBtSortCountryThenSportClearOthers =
    onBtSortCountryThenSportClearOthers;
  (<any>window).onBtClearAllSorting = onBtClearAllSorting;
  (<any>window).onBtRowGroupCountryThenSport = onBtRowGroupCountryThenSport;
  (<any>window).onBtRemoveCountryRowGroup = onBtRemoveCountryRowGroup;
  (<any>window).onBtClearAllRowGroups = onBtClearAllRowGroups;
  (<any>window).onBtOrderColsMedalsFirst = onBtOrderColsMedalsFirst;
  (<any>window).onBtOrderColsMedalsLast = onBtOrderColsMedalsLast;
  (<any>window).onBtHideMedals = onBtHideMedals;
  (<any>window).onBtShowMedals = onBtShowMedals;
}
```

[Live example: Fine Grained State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/fine-grained-state/typescript/)

### Saving Partial State

Using the techniques above, it is possible to save and restore a subset of the parameters in the state. The example below demonstrates this by selectively saving and restoring a) sort state, and b) column visibility and order state.

Note that when saving and restoring Sort state, other state attributes (width, row group, column order etc) are not impacted.

Likewise when saving and restoring visibility and order, only visibility and order will be impacted when re-applying the state.

#### Selective State

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

declare let window: any;

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete" },
  { field: "age" },
  { field: "country" },
  { field: "sport" },
  { field: "year" },
  { field: "date" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
  { field: "total" },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 100,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  autoGroupColumnDef: {
    minWidth: 200,
  },
  sideBar: {
    toolPanels: ["columns"],
  },
  rowGroupPanelShow: "always",
  pivotPanelShow: "always",
  // debug: true,
  columnDefs: columnDefs,
};

function onBtSaveSortState() {
  const allState = gridApi!.getColumnState();
  const sortState = allState.map((state) => ({
    colId: state.colId,
    sort: state.sort,
    sortIndex: state.sortIndex,
  }));
  window.sortState = sortState;
  console.log("sort state saved", sortState);
}

function onBtRestoreSortState() {
  if (!window.sortState) {
    console.log("no sort state to restore, you must save sort state first");
    return;
  }
  gridApi!.applyColumnState({
    state: window.sortState,
  });
  console.log("sort state restored");
}

function onBtSaveOrderAndVisibilityState() {
  const allState = gridApi!.getColumnState();
  const orderAndVisibilityState = allState.map((state) => ({
    colId: state.colId,
    hide: state.hide,
  }));
  window.orderAndVisibilityState = orderAndVisibilityState;
  console.log("order and visibility state saved", orderAndVisibilityState);
}

function onBtRestoreOrderAndVisibilityState() {
  if (!window.orderAndVisibilityState) {
    console.log(
      "no order and visibility state to restore by, you must save order and visibility state first",
    );
    return;
  }
  gridApi!.applyColumnState({
    state: window.orderAndVisibilityState,
    applyOrder: true,
  });
  console.log("column state restored");
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtSaveSortState = onBtSaveSortState;
  (<any>window).onBtRestoreSortState = onBtRestoreSortState;
  (<any>window).onBtSaveOrderAndVisibilityState =
    onBtSaveOrderAndVisibilityState;
  (<any>window).onBtRestoreOrderAndVisibilityState =
    onBtRestoreOrderAndVisibilityState;
}
```

[Live example: Selective State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/selective-state/typescript/)

## Considerations

There are a few items to note on specific state attributes. They are as follows:

### Column IDs

Column state is keyed by [Column ID](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-updating-definitions/#matching-columns), so give every column a `colId` or a `field` if you intend to save and re-apply its state. A column with neither is identified by its position in `columnDefs`, which means state saved before a reorder is re-applied to a different column. See [Grid State](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-state/#state-contents) for details.

### null vs undefined

For all state attributes, `undefined` means *"do not apply this attribute"* and `null` means *"clear this attribute"*.

For example setting `sort=null` will clear sort on a column whereas setting `sort=undefined` will leave whatever sort, if any, that is currently present.

The only exception is Column Width. Setting `null` is not supported because width is mandatory - there is no such thing as a Column with no width.

### Row Group and Pivot

There are two attributes representing both Row Group and Pivot. First using the boolean attributes `rowGroup` and `pivot` and then secondly using the index attributes `rowGroupIndex` and `pivotIndex`.

When `getColumnState()` is called, all of `rowGroup`, `pivot`, `rowGroupIndex` and `pivotIndex` are returned. When `applyColumnState()` is called, preference is given to the index variants. For example if both `rowGroup` and `rowGroupIndex` are present, `rowGroupIndex` is applied.

## Column Events

Column Events will get raised when applying a Column State as these events would normally get raised. For example `columnPinned` event will get raised if applying the state results in a column getting pinned or unpinned.

The example below demonstrates events getting raised based on Column State changes. The example logs event information to the console.

#### Column Events

```ts
import {
  ClientSideRowModelModule,
  ColDef,
  Column,
  ColumnApiModule,
  ColumnMovedEvent,
  ColumnPinnedEvent,
  ColumnPivotChangedEvent,
  ColumnResizedEvent,
  ColumnRowGroupChangedEvent,
  ColumnValueChangedEvent,
  ColumnVisibleEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SortChangedEvent,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  PivotModule,
]);

const columnDefs: ColDef[] = [
  { field: "athlete" },
  { field: "age" },
  { field: "country" },
  { field: "sport" },
  { field: "gold" },
  { field: "silver" },
  { field: "bronze" },
];

function onSortChanged(e: SortChangedEvent) {
  console.log("Event Sort Changed", e);
}

function onColumnResized(e: ColumnResizedEvent) {
  console.log("Event Column Resized", e);
}

function onColumnVisible(e: ColumnVisibleEvent) {
  console.log("Event Column Visible", e);
}

function onColumnPivotChanged(e: ColumnPivotChangedEvent) {
  console.log("Event Pivot Changed", e);
}

function onColumnRowGroupChanged(e: ColumnRowGroupChangedEvent) {
  console.log("Event Row Group Changed", e);
}

function onColumnValueChanged(e: ColumnValueChangedEvent) {
  console.log("Event Value Changed", e);
}

function onColumnMoved(e: ColumnMovedEvent) {
  console.log("Event Column Moved", e);
}

function onColumnPinned(e: ColumnPinnedEvent) {
  console.log("Event Column Pinned", e);
}

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 150,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  },
  // debug: true,
  columnDefs: columnDefs,
  onSortChanged: onSortChanged,
  onColumnResized: onColumnResized,
  onColumnVisible: onColumnVisible,
  onColumnPivotChanged: onColumnPivotChanged,
  onColumnRowGroupChanged: onColumnRowGroupChanged,
  onColumnValueChanged: onColumnValueChanged,
  onColumnMoved: onColumnMoved,
  onColumnPinned: onColumnPinned,
};

function onBtSortOn() {
  gridApi!.applyColumnState({
    state: [
      { colId: "age", sort: "desc" },
      { colId: "athlete", sort: "asc" },
    ],
  });
}

function onBtSortOff() {
  gridApi!.applyColumnState({
    defaultState: { sort: null },
  });
}

function onBtWidthNarrow() {
  gridApi!.applyColumnState({
    state: [
      { colId: "age", width: 100 },
      { colId: "athlete", width: 100 },
    ],
  });
}

function onBtWidthNormal() {
  gridApi!.applyColumnState({
    state: [
      { colId: "age", width: 200 },
      { colId: "athlete", width: 200 },
    ],
  });
}

function onBtHide() {
  gridApi!.applyColumnState({
    state: [
      { colId: "age", hide: true },
      { colId: "athlete", hide: true },
    ],
  });
}

function onBtShow() {
  gridApi!.applyColumnState({
    defaultState: { hide: false },
  });
}

function onBtPivotOn() {
  gridApi!.setGridOption("pivotMode", true);
  gridApi!.applyColumnState({
    state: [{ colId: "country", pivot: true }],
  });
}

function onBtPivotOff() {
  gridApi!.setGridOption("pivotMode", false);
  gridApi!.applyColumnState({
    defaultState: { pivot: false },
  });
}

function onBtRowGroupOn() {
  gridApi!.applyColumnState({
    state: [{ colId: "sport", rowGroup: true }],
  });
}

function onBtRowGroupOff() {
  gridApi!.applyColumnState({
    defaultState: { rowGroup: false },
  });
}

function onBtAggFuncOn() {
  gridApi!.applyColumnState({
    state: [
      { colId: "gold", aggFunc: "sum" },
      { colId: "silver", aggFunc: "sum" },
      { colId: "bronze", aggFunc: "sum" },
    ],
  });
}

function onBtAggFuncOff() {
  gridApi!.applyColumnState({
    defaultState: { aggFunc: null },
  });
}

function onBtNormalOrder() {
  gridApi!.applyColumnState({
    state: [
      { colId: "athlete" },
      { colId: "age" },
      { colId: "country" },
      { colId: "sport" },
      { colId: "gold" },
      { colId: "silver" },
      { colId: "bronze" },
    ],
    applyOrder: true,
  });
}

function onBtReverseOrder() {
  gridApi!.applyColumnState({
    state: [
      { colId: "athlete" },
      { colId: "age" },
      { colId: "country" },
      { colId: "sport" },
      { colId: "bronze" },
      { colId: "silver" },
      { colId: "gold" },
    ],
    applyOrder: true,
  });
}

function onBtPinnedOn() {
  gridApi!.applyColumnState({
    state: [
      { colId: "athlete", pinned: "left" },
      { colId: "sport", pinned: "right" },
    ],
  });
}

function onBtPinnedOff() {
  gridApi!.applyColumnState({
    defaultState: { pinned: null },
  });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onBtSortOn = onBtSortOn;
  (<any>window).onBtSortOff = onBtSortOff;
  (<any>window).onBtWidthNarrow = onBtWidthNarrow;
  (<any>window).onBtWidthNormal = onBtWidthNormal;
  (<any>window).onBtHide = onBtHide;
  (<any>window).onBtShow = onBtShow;
  (<any>window).onBtPivotOn = onBtPivotOn;
  (<any>window).onBtPivotOff = onBtPivotOff;
  (<any>window).onBtRowGroupOn = onBtRowGroupOn;
  (<any>window).onBtRowGroupOff = onBtRowGroupOff;
  (<any>window).onBtAggFuncOn = onBtAggFuncOn;
  (<any>window).onBtAggFuncOff = onBtAggFuncOff;
  (<any>window).onBtNormalOrder = onBtNormalOrder;
  (<any>window).onBtReverseOrder = onBtReverseOrder;
  (<any>window).onBtPinnedOn = onBtPinnedOn;
  (<any>window).onBtPinnedOff = onBtPinnedOff;
}
```

[Live example: Column Events](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-events/typescript/)

## Column Group State

Column Group State is concerned with the state of Column Groups. There is only one state attribute for Column Groups, which is whether the group is open or closed.

To get the state of Column Groups use the API method `api.getColumnGroupState()`. To set the Column Group state use the API method `api.setColumnGroupState(stateItems)`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnGroupState` | `Function` |  |  |  |
| `setColumnGroupState` | `Function` |  |  |  |
| `resetColumnGroupState` | `Function` |  |  |  |

The example below demonstrates getting and setting Column Group State. Note the following:

- Clicking 'Save State' will save the opened / closed state of column groups.
- Clicking 'Restore State' will restore the previously saved state.
- Clicking 'Reset State' will reset the column state to match the Column Definitions, i.e. all Column Groups will be closed.

#### Column Group State

```ts
import {
  ClientSideRowModelModule,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

declare let window: any;

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);

const columnDefs: ColGroupDef[] = [
  {
    headerName: "Athlete",
    children: [
      { field: "athlete" },
      { field: "country", columnGroupShow: "open" },
      { field: "sport", columnGroupShow: "open" },
      { field: "year", columnGroupShow: "open" },
      { field: "date", columnGroupShow: "open" },
    ],
  },
  {
    headerName: "Medals",
    children: [
      { field: "total", columnGroupShow: "closed" },
      { field: "gold", columnGroupShow: "open" },
      { field: "silver", columnGroupShow: "open" },
      { field: "bronze", columnGroupShow: "open" },
    ],
  },
];

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  defaultColDef: {
    width: 150,
  },
  columnDefs: columnDefs,
};

function saveState() {
  window.groupState = gridApi!.getColumnGroupState();
  console.log("group state saved", window.groupState);
  console.log("column group state saved");
}

function restoreState() {
  if (!window.groupState) {
    console.log("no columns state to restore by, you must save state first");
    return;
  }
  gridApi!.setColumnGroupState(window.groupState);
  console.log("column group state restored");
}

function resetState() {
  gridApi!.resetColumnGroupState();
  console.log("column group state reset");
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).saveState = saveState;
  (<any>window).restoreState = restoreState;
  (<any>window).resetState = resetState;
}
```

[Live example: Column Group State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-group-state/typescript/)


---
product: "AG Grid"
title: "Column State"
description: "The full list of stateful attributes of Columns are represented by the ColumnStateParams interface:"
framework: vue
version: "36.2.0"
related:
    - title: "Column Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-definitions/"
    - title: "Updating Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-updating-definitions/"
    - title: "Auto-Generate Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/auto-generate-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column State

Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change).

> **Note**
>
> The DOM also has stateful vs non-stateful attributes. For example consider a DOM element and setting `element.style.width="100px"` will indefinitely set width to 100 pixels, the browser will not change this value. However setting `element.scrollTop=200` will set the scroll position, but the browser can change the scroll position further following user interaction, thus scroll position is stateful as the browser can change the state.

The full list of stateful attributes of Columns are represented by the `ColumnStateParams` interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `hide` | `boolean \| null` |  |  |  |
| `width` | `number \| null` |  |  |  |
| `flex` | `number \| null` |  |  |  |
| `sort` | `SortDirection` |  |  |  |
| `sortType` | `SortType \| null` |  |  |  |
| `sortIndex` | `number \| null` |  |  |  |
| `aggFunc` | `string \| IAggFunc \| null` |  |  |  |
| `valueIndex` | `number \| null` |  |  |  |
| `pivot` | `boolean \| null` |  |  |  |
| `pivotIndex` | `number \| null` |  |  |  |
| `pivotSort` | `SortDirection` |  |  |  |
| `pinned` | `ColumnPinnedType` |  |  |  |
| `rowGroup` | `boolean \| null` |  |  |  |
| `rowGroupIndex` | `number \| null` |  |  |  |
| `showValuesAs` | `ShowValuesAsStateValue` |  |  |  |
| `headerName` | `string \| null` |  |  |  |

This section details how such state items can be manipulated without having to update Column Definitions.

## Save and Apply State

> **Note**
>
> If you want to save and restore the whole grid rather than manipulate individual column attributes, consider [Grid State](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/) instead. It contains all of the Column State properties alongside the other grid state sections — including [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/calculated-columns/) added at runtime, which Column State alone cannot recreate — and can be applied on initialisation via `initialState` or at runtime via `api.setState()`.

There are two API methods provided for getting and setting Column State. `api.getColumnState()` gets the current column state and `api.applyColumnState(params)` sets the column state.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnState` | `Function` |  |  |  |
| `applyColumnState` | `Function` |  |  |  |
| `resetColumnState` | `Function` |  |  |  |

The example below demonstrates saving and restoring column state. Try the following:

1. Click 'Save State' to save the Column State.
2. Change some column state, e.g. resize columns, move columns around, apply column sorting or row grouping, or rename an [editable header](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-headers/#editable-header-name) from its column menu, etc.
3. Click 'Restore State' and the column state is set back to where it was when you clicked 'Save State'.
4. Click 'Reset State' and the state will go back to what was defined in the Column Definitions.

#### Save and Apply State

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnHeaderEditModule,
  ColumnMenuModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnHeaderEditModule,
  ColumnMenuModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);

declare let window: any;

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <div class="example-section">
          <button v-on:click="saveState()">Save State</button>
          <button v-on:click="restoreState()">Restore State</button>
          <button v-on:click="resetState()">Reset State</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :autoGroupColumnDef="autoGroupColumnDef"
        :sideBar="sideBar"
        :rowGroupPanelShow="rowGroupPanelShow"
        :pivotPanelShow="pivotPanelShow"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", headerNameEditable: true },
      { field: "age", headerNameEditable: true },
      { field: "country", headerNameEditable: true },
      { field: "sport" },
      { field: "year" },
      { field: "date" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 100,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: ["columns"],
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const pivotPanelShow = ref<"always" | "onlyWhenPivoting" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    function saveState() {
      window.colState = gridApi.value!.getColumnState();
      console.log("column state saved");
    }
    function restoreState() {
      if (!window.colState) {
        console.log(
          "no columns state to restore by, you must save state first",
        );
        return;
      }
      gridApi.value!.applyColumnState({
        state: window.colState,
        applyOrder: true,
      });
      console.log("column state restored");
    }
    function resetState() {
      gridApi.value!.resetColumnState();
      console.log("column state reset");
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowGroupPanelShow,
      pivotPanelShow,
      rowData,
      onGridReady,
      saveState,
      restoreState,
      resetState,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Save and Apply State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/save-apply-state/vue3/)

## Partial State

It is possible to focus on particular columns and / or particular attributes when getting and / or applying a Column State. This allows fine grained control over the Column State, e.g. setting what Columns are Pinned, without impacting any other state attribute.

### Applying Partial State

When applying a Column State, in cases where some state attributes or columns are missing from the Column State, the following rules apply:

- Attributes that are not supplied or are set to `undefined` will remain unchanged. For example if a Column has a Column State with just `pinned`, then Pinned is applied to that Column but other attributes, such as `sort` are left intact.
- When state is applied and there are additional Columns in the grid that do not appear in the provided state, then the `params.defaultState` is applied to those additional Columns.
- If `params.defaultState` is not provided, then any additional Columns in the grid will not be updated.

Combining these rules together allows flexible fine-grained state control. Take the following code snippets as examples:

```ts
// Sort Athlete column ascending
this.gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ]
});

// Sort Athlete column ascending and clear sort on all other columns
this.gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ],
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting on all columns, leave all other attributes untouched
this.gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting, row group, pivot and pinned on all columns, leave all other attributes untouched
this.gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null,
        rowGroup: null,
        pivot: null,
        pinned: null
    }
});

// Order columns, but do nothing else
this.gridApi.applyColumnState({
    state: [
        { colId: 'athlete' },
        { colId: 'country' },
        { colId: 'age' },
        { colId: 'sport' }
    ],
    applyOrder: true
});
```

The example below shows some fine grained access to Column State.

#### Fine Grained State

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <table>
          <tbody><tr>
            <td>Sort:</td>
            <td>
              <button v-on:click="onBtSortAthlete()">Sort Athlete</button>
              <button v-on:click="onBtSortCountryThenSportClearOthers()">
                Sort Country, then Sport - Clear Others
              </button>
              <button v-on:click="onBtClearAllSorting()">Clear All Sorting</button>
            </td>
          </tr>
          <tr>
            <td>Column Order:</td>
            <td>
              <button v-on:click="onBtOrderColsMedalsFirst()">Show Medals First</button>
              <button v-on:click="onBtOrderColsMedalsLast()">Show Medals Last</button>
            </td>
          </tr>
          <tr>
            <td>Column Visibility:</td>
            <td>
              <button v-on:click="onBtHideMedals()">Hide Medals</button>
              <button v-on:click="onBtShowMedals()">Show Medals</button>
            </td>
          </tr>
          <tr>
            <td>Row Group:</td>
            <td>
              <button v-on:click="onBtRowGroupCountryThenSport()">Group Country then Sport</button>
              <button v-on:click="onBtRemoveCountryRowGroup()">Remove Country</button>
              <button v-on:click="onBtClearAllRowGroups()">Clear All Groups</button>
            </td>
          </tr>
          </tbody></table>
        </div>
        <ag-grid-vue
          style="width: 100%; height: 100%;"
          @grid-ready="onGridReady"
          :columnDefs="columnDefs"
          :defaultColDef="defaultColDef"
          :autoGroupColumnDef="autoGroupColumnDef"
          :sideBar="sideBar"
          :rowGroupPanelShow="rowGroupPanelShow"
          :pivotPanelShow="pivotPanelShow"
          :rowData="rowData"></ag-grid-vue>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "date" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 150,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: ["columns"],
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const pivotPanelShow = ref<"always" | "onlyWhenPivoting" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    function onBtSortAthlete() {
      gridApi.value!.applyColumnState({
        state: [{ colId: "athlete", sort: "asc" }],
      });
    }
    function onBtSortCountryThenSportClearOthers() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "country", sort: "asc", sortIndex: 0 },
          { colId: "sport", sort: "asc", sortIndex: 1 },
        ],
        defaultState: { sort: null },
      });
    }
    function onBtClearAllSorting() {
      gridApi.value!.applyColumnState({
        defaultState: { sort: null },
      });
    }
    function onBtRowGroupCountryThenSport() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "country", rowGroupIndex: 0 },
          { colId: "sport", rowGroupIndex: 1 },
        ],
        defaultState: { rowGroup: false },
      });
    }
    function onBtRemoveCountryRowGroup() {
      gridApi.value!.applyColumnState({
        state: [{ colId: "country", rowGroup: false }],
      });
    }
    function onBtClearAllRowGroups() {
      gridApi.value!.applyColumnState({
        defaultState: { rowGroup: false },
      });
    }
    function onBtOrderColsMedalsFirst() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "gold" },
          { colId: "silver" },
          { colId: "bronze" },
          { colId: "total" },
          { colId: "athlete" },
          { colId: "age" },
          { colId: "country" },
          { colId: "sport" },
          { colId: "year" },
          { colId: "date" },
        ],
        applyOrder: true,
      });
    }
    function onBtOrderColsMedalsLast() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "athlete" },
          { colId: "age" },
          { colId: "country" },
          { colId: "sport" },
          { colId: "year" },
          { colId: "date" },
          { colId: "gold" },
          { colId: "silver" },
          { colId: "bronze" },
          { colId: "total" },
        ],
        applyOrder: true,
      });
    }
    function onBtHideMedals() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "gold", hide: true },
          { colId: "silver", hide: true },
          { colId: "bronze", hide: true },
          { colId: "total", hide: true },
        ],
      });
    }
    function onBtShowMedals() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "gold", hide: false },
          { colId: "silver", hide: false },
          { colId: "bronze", hide: false },
          { colId: "total", hide: false },
        ],
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowGroupPanelShow,
      pivotPanelShow,
      rowData,
      onGridReady,
      onBtSortAthlete,
      onBtSortCountryThenSportClearOthers,
      onBtClearAllSorting,
      onBtRowGroupCountryThenSport,
      onBtRemoveCountryRowGroup,
      onBtClearAllRowGroups,
      onBtOrderColsMedalsFirst,
      onBtOrderColsMedalsLast,
      onBtHideMedals,
      onBtShowMedals,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Fine Grained State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/fine-grained-state/vue3/)

### Saving Partial State

Using the techniques above, it is possible to save and restore a subset of the parameters in the state. The example below demonstrates this by selectively saving and restoring a) sort state, and b) column visibility and order state.

Note that when saving and restoring Sort state, other state attributes (width, row group, column order etc) are not impacted.

Likewise when saving and restoring visibility and order, only visibility and order will be impacted when re-applying the state.

#### Selective State

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);

declare let window: any;

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <div class="example-section">
          <button v-on:click="onBtSaveSortState()">Save Sort</button>
          <button v-on:click="onBtRestoreSortState()">Restore Sort</button>
          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          <button v-on:click="onBtSaveOrderAndVisibilityState()">Save Order &amp; Visibility</button>
          <button v-on:click="onBtRestoreOrderAndVisibilityState()">Restore Order &amp; Visibility</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :autoGroupColumnDef="autoGroupColumnDef"
        :sideBar="sideBar"
        :rowGroupPanelShow="rowGroupPanelShow"
        :pivotPanelShow="pivotPanelShow"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "date" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
      { field: "total" },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 100,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 200,
    });
    const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
      toolPanels: ["columns"],
    });
    const rowGroupPanelShow = ref<"always" | "onlyWhenGrouping" | "never">(
      "always",
    );
    const pivotPanelShow = ref<"always" | "onlyWhenPivoting" | "never">(
      "always",
    );
    const rowData = ref<IOlympicData[]>(null);

    function onBtSaveSortState() {
      const allState = gridApi.value!.getColumnState();
      const sortState = allState.map((state) => ({
        colId: state.colId,
        sort: state.sort,
        sortIndex: state.sortIndex,
      }));
      window.sortState = sortState;
      console.log("sort state saved", sortState);
    }
    function onBtRestoreSortState() {
      if (!window.sortState) {
        console.log("no sort state to restore, you must save sort state first");
        return;
      }
      gridApi.value!.applyColumnState({
        state: window.sortState,
      });
      console.log("sort state restored");
    }
    function onBtSaveOrderAndVisibilityState() {
      const allState = gridApi.value!.getColumnState();
      const orderAndVisibilityState = allState.map((state) => ({
        colId: state.colId,
        hide: state.hide,
      }));
      window.orderAndVisibilityState = orderAndVisibilityState;
      console.log("order and visibility state saved", orderAndVisibilityState);
    }
    function onBtRestoreOrderAndVisibilityState() {
      if (!window.orderAndVisibilityState) {
        console.log(
          "no order and visibility state to restore by, you must save order and visibility state first",
        );
        return;
      }
      gridApi.value!.applyColumnState({
        state: window.orderAndVisibilityState,
        applyOrder: true,
      });
      console.log("column state restored");
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      sideBar,
      rowGroupPanelShow,
      pivotPanelShow,
      rowData,
      onGridReady,
      onBtSaveSortState,
      onBtRestoreSortState,
      onBtSaveOrderAndVisibilityState,
      onBtRestoreOrderAndVisibilityState,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Selective State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/selective-state/vue3/)

## Considerations

There are a few items to note on specific state attributes. They are as follows:

### Column IDs

Column state is keyed by [Column ID](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-updating-definitions/#matching-columns), so give every column a `colId` or a `field` if you intend to save and re-apply its state. A column with neither is identified by its position in `columnDefs`, which means state saved before a reorder is re-applied to a different column. See [Grid State](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-state/#state-contents) for details.

### null vs undefined

For all state attributes, `undefined` means *"do not apply this attribute"* and `null` means *"clear this attribute"*.

For example setting `sort=null` will clear sort on a column whereas setting `sort=undefined` will leave whatever sort, if any, that is currently present.

The only exception is Column Width. Setting `null` is not supported because width is mandatory - there is no such thing as a Column with no width.

### Row Group and Pivot

There are two attributes representing both Row Group and Pivot. First using the boolean attributes `rowGroup` and `pivot` and then secondly using the index attributes `rowGroupIndex` and `pivotIndex`.

When `getColumnState()` is called, all of `rowGroup`, `pivot`, `rowGroupIndex` and `pivotIndex` are returned. When `applyColumnState()` is called, preference is given to the index variants. For example if both `rowGroup` and `rowGroupIndex` are present, `rowGroupIndex` is applied.

## Column Events

Column Events will get raised when applying a Column State as these events would normally get raised. For example `columnPinned` event will get raised if applying the state results in a column getting pinned or unpinned.

The example below demonstrates events getting raised based on Column State changes. The example logs event information to the console.

#### Column Events

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  Column,
  ColumnApiModule,
  ColumnMovedEvent,
  ColumnPinnedEvent,
  ColumnPivotChangedEvent,
  ColumnResizedEvent,
  ColumnRowGroupChangedEvent,
  ColumnValueChangedEvent,
  ColumnVisibleEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SortChangedEvent,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  PivotModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <div class="test-button-row">
          <div class="test-button-group">
            <button v-on:click="onBtSortOn()">Sort On</button>
            <br />
            <button v-on:click="onBtSortOff()">Sort Off</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtWidthNarrow()">Width Narrow</button>
            <br />
            <button v-on:click="onBtWidthNormal()">Width Normal</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtHide()">Hide Cols</button>
            <br />
            <button v-on:click="onBtShow()">Show Cols</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtReverseOrder()">Reverse Medal Order</button>
            <br />
            <button v-on:click="onBtNormalOrder()">Normal Medal Order</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtRowGroupOn()">Row Group On</button>
            <br />
            <button v-on:click="onBtRowGroupOff()">Row Group Off</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtAggFuncOn()">Agg Func On</button>
            <br />
            <button v-on:click="onBtAggFuncOff()">Agg Func Off</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtPivotOn()">Pivot On</button>
            <br />
            <button v-on:click="onBtPivotOff()">Pivot Off</button>
          </div>
          <div class="test-button-group">
            <button v-on:click="onBtPinnedOn()">Pinned On</button>
            <br />
            <button v-on:click="onBtPinnedOff()">Pinned Off</button>
          </div>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"
        @sort-changed="onSortChanged"
        @column-resized="onColumnResized"
        @column-visible="onColumnVisible"
        @column-pivot-changed="onColumnPivotChanged"
        @column-row-group-changed="onColumnRowGroupChanged"
        @column-value-changed="onColumnValueChanged"
        @column-moved="onColumnMoved"
        @column-pinned="onColumnPinned"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "age" },
      { field: "country" },
      { field: "sport" },
      { field: "gold" },
      { field: "silver" },
      { field: "bronze" },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 150,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    function onSortChanged(e: SortChangedEvent) {
      console.log("Event Sort Changed", e);
    }
    function onColumnResized(e: ColumnResizedEvent) {
      console.log("Event Column Resized", e);
    }
    function onColumnVisible(e: ColumnVisibleEvent) {
      console.log("Event Column Visible", e);
    }
    function onColumnPivotChanged(e: ColumnPivotChangedEvent) {
      console.log("Event Pivot Changed", e);
    }
    function onColumnRowGroupChanged(e: ColumnRowGroupChangedEvent) {
      console.log("Event Row Group Changed", e);
    }
    function onColumnValueChanged(e: ColumnValueChangedEvent) {
      console.log("Event Value Changed", e);
    }
    function onColumnMoved(e: ColumnMovedEvent) {
      console.log("Event Column Moved", e);
    }
    function onColumnPinned(e: ColumnPinnedEvent) {
      console.log("Event Column Pinned", e);
    }
    function onBtSortOn() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "age", sort: "desc" },
          { colId: "athlete", sort: "asc" },
        ],
      });
    }
    function onBtSortOff() {
      gridApi.value!.applyColumnState({
        defaultState: { sort: null },
      });
    }
    function onBtWidthNarrow() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "age", width: 100 },
          { colId: "athlete", width: 100 },
        ],
      });
    }
    function onBtWidthNormal() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "age", width: 200 },
          { colId: "athlete", width: 200 },
        ],
      });
    }
    function onBtHide() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "age", hide: true },
          { colId: "athlete", hide: true },
        ],
      });
    }
    function onBtShow() {
      gridApi.value!.applyColumnState({
        defaultState: { hide: false },
      });
    }
    function onBtPivotOn() {
      gridApi.value!.setGridOption("pivotMode", true);
      gridApi.value!.applyColumnState({
        state: [{ colId: "country", pivot: true }],
      });
    }
    function onBtPivotOff() {
      gridApi.value!.setGridOption("pivotMode", false);
      gridApi.value!.applyColumnState({
        defaultState: { pivot: false },
      });
    }
    function onBtRowGroupOn() {
      gridApi.value!.applyColumnState({
        state: [{ colId: "sport", rowGroup: true }],
      });
    }
    function onBtRowGroupOff() {
      gridApi.value!.applyColumnState({
        defaultState: { rowGroup: false },
      });
    }
    function onBtAggFuncOn() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "gold", aggFunc: "sum" },
          { colId: "silver", aggFunc: "sum" },
          { colId: "bronze", aggFunc: "sum" },
        ],
      });
    }
    function onBtAggFuncOff() {
      gridApi.value!.applyColumnState({
        defaultState: { aggFunc: null },
      });
    }
    function onBtNormalOrder() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "athlete" },
          { colId: "age" },
          { colId: "country" },
          { colId: "sport" },
          { colId: "gold" },
          { colId: "silver" },
          { colId: "bronze" },
        ],
        applyOrder: true,
      });
    }
    function onBtReverseOrder() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "athlete" },
          { colId: "age" },
          { colId: "country" },
          { colId: "sport" },
          { colId: "bronze" },
          { colId: "silver" },
          { colId: "gold" },
        ],
        applyOrder: true,
      });
    }
    function onBtPinnedOn() {
      gridApi.value!.applyColumnState({
        state: [
          { colId: "athlete", pinned: "left" },
          { colId: "sport", pinned: "right" },
        ],
      });
    }
    function onBtPinnedOff() {
      gridApi.value!.applyColumnState({
        defaultState: { pinned: null },
      });
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onSortChanged,
      onColumnResized,
      onColumnVisible,
      onColumnPivotChanged,
      onColumnRowGroupChanged,
      onColumnValueChanged,
      onColumnMoved,
      onColumnPinned,
      onBtSortOn,
      onBtSortOff,
      onBtWidthNarrow,
      onBtWidthNormal,
      onBtHide,
      onBtShow,
      onBtPivotOn,
      onBtPivotOff,
      onBtRowGroupOn,
      onBtRowGroupOff,
      onBtAggFuncOn,
      onBtAggFuncOff,
      onBtNormalOrder,
      onBtReverseOrder,
      onBtPinnedOn,
      onBtPinnedOff,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Column Events](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-events/vue3/)

## Column Group State

Column Group State is concerned with the state of Column Groups. There is only one state attribute for Column Groups, which is whether the group is open or closed.

To get the state of Column Groups use the API method `api.getColumnGroupState()`. To set the Column Group state use the API method `api.setColumnGroupState(stateItems)`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnGroupState` | `Function` |  |  |  |
| `setColumnGroupState` | `Function` |  |  |  |
| `resetColumnGroupState` | `Function` |  |  |  |

The example below demonstrates getting and setting Column Group State. Note the following:

- Clicking 'Save State' will save the opened / closed state of column groups.
- Clicking 'Restore State' will restore the previously saved state.
- Clicking 'Reset State' will reset the column state to match the Column Definitions, i.e. all Column Groups will be closed.

#### Column Group State

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);

declare let window: any;

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-container">
      <div class="test-header">
        <div class="example-section">
          Column State:
          <button v-on:click="saveState()">Save State</button>
          <button v-on:click="restoreState()">Restore State</button>
          <button v-on:click="resetState()">Reset State</button>
        </div>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      {
        headerName: "Athlete",
        children: [
          { field: "athlete" },
          { field: "country", columnGroupShow: "open" },
          { field: "sport", columnGroupShow: "open" },
          { field: "year", columnGroupShow: "open" },
          { field: "date", columnGroupShow: "open" },
        ],
      },
      {
        headerName: "Medals",
        children: [
          { field: "total", columnGroupShow: "closed" },
          { field: "gold", columnGroupShow: "open" },
          { field: "silver", columnGroupShow: "open" },
          { field: "bronze", columnGroupShow: "open" },
        ],
      },
    ]);
    const defaultColDef = ref<ColDef>({
      width: 150,
    });
    const rowData = ref<IOlympicData[]>(null);

    function saveState() {
      window.groupState = gridApi.value!.getColumnGroupState();
      console.log("group state saved", window.groupState);
      console.log("column group state saved");
    }
    function restoreState() {
      if (!window.groupState) {
        console.log(
          "no columns state to restore by, you must save state first",
        );
        return;
      }
      gridApi.value!.setColumnGroupState(window.groupState);
      console.log("column group state restored");
    }
    function resetState() {
      gridApi.value!.resetColumnGroupState();
      console.log("column group state reset");
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      saveState,
      restoreState,
      resetState,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Column Group State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-group-state/vue3/)


---
product: "AG Grid"
title: "Column State"
description: "Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change)."
framework: react
version: "36.2.0"
related:
    - title: "Column Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-definitions/"
    - title: "Updating Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-updating-definitions/"
    - title: "Auto-Generate Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/auto-generate-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column State

Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change).

[React Column State](https://www.youtube.com/watch?v=d9Kohpbt42M)

> **Note**
>
> The DOM also has stateful vs non-stateful attributes. For example consider a DOM element and setting `element.style.width="100px"` will indefinitely set width to 100 pixels, the browser will not change this value. However setting `element.scrollTop=200` will set the scroll position, but the browser can change the scroll position further following user interaction, thus scroll position is stateful as the browser can change the state.

The full list of stateful attributes of Columns are represented by the `ColumnStateParams` interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `hide` | `boolean \| null` |  |  |  |
| `width` | `number \| null` |  |  |  |
| `flex` | `number \| null` |  |  |  |
| `sort` | `SortDirection` |  |  |  |
| `sortType` | `SortType \| null` |  |  |  |
| `sortIndex` | `number \| null` |  |  |  |
| `aggFunc` | `string \| IAggFunc \| null` |  |  |  |
| `valueIndex` | `number \| null` |  |  |  |
| `pivot` | `boolean \| null` |  |  |  |
| `pivotIndex` | `number \| null` |  |  |  |
| `pivotSort` | `SortDirection` |  |  |  |
| `pinned` | `ColumnPinnedType` |  |  |  |
| `rowGroup` | `boolean \| null` |  |  |  |
| `rowGroupIndex` | `number \| null` |  |  |  |
| `showValuesAs` | `ShowValuesAsStateValue` |  |  |  |
| `headerName` | `string \| null` |  |  |  |

This section details how such state items can be manipulated without having to update Column Definitions.

## Save and Apply State

> **Note**
>
> If you want to save and restore the whole grid rather than manipulate individual column attributes, consider [Grid State](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/) instead. It contains all of the Column State properties alongside the other grid state sections — including [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/react-data-grid/calculated-columns/) added at runtime, which Column State alone cannot recreate — and can be applied on initialisation via `initialState` or at runtime via `api.setState()`.

There are two API methods provided for getting and setting Column State. `api.getColumnState()` gets the current column state and `api.applyColumnState(params)` sets the column state.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnState` | `Function` |  |  |  |
| `applyColumnState` | `Function` |  |  |  |
| `resetColumnState` | `Function` |  |  |  |

The example below demonstrates saving and restoring column state. Try the following:

1. Click 'Save State' to save the Column State.
2. Change some column state, e.g. resize columns, move columns around, apply column sorting or row grouping, or rename an [editable header](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-headers/#editable-header-name) from its column menu, etc.
3. Click 'Restore State' and the column state is set back to where it was when you clicked 'Save State'.
4. Click 'Reset State' and the state will go back to what was defined in the Column Definitions.

#### Save and Apply State

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnHeaderEditModule,
  ColumnMenuModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnHeaderEditModule,
  ColumnMenuModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
];

declare let window: any;

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", headerNameEditable: true },
    { field: "age", headerNameEditable: true },
    { field: "country", headerNameEditable: true },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 100,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);
  const sideBar = useMemo<
    SideBarDef | string | string[] | boolean | null
  >(() => {
    return {
      toolPanels: ["columns"],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const saveState = useCallback(() => {
    window.colState = gridRef.current!.api.getColumnState();
    console.log("column state saved");
  }, []);

  const restoreState = useCallback(() => {
    if (!window.colState) {
      console.log("no columns state to restore by, you must save state first");
      return;
    }
    gridRef.current!.api.applyColumnState({
      state: window.colState,
      applyOrder: true,
    });
    console.log("column state restored");
  }, [window]);

  const resetState = useCallback(() => {
    gridRef.current!.api.resetColumnState();
    console.log("column state reset");
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <div className="example-section">
              <button onClick={saveState}>Save State</button>
              <button onClick={restoreState}>Restore State</button>
              <button onClick={resetState}>Reset State</button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              sideBar={sideBar}
              rowGroupPanelShow={"always"}
              pivotPanelShow={"always"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Save and Apply State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/save-apply-state/reactFunctionalTs/)

## Partial State

It is possible to focus on particular columns and / or particular attributes when getting and / or applying a Column State. This allows fine grained control over the Column State, e.g. setting what Columns are Pinned, without impacting any other state attribute.

### Applying Partial State

When applying a Column State, in cases where some state attributes or columns are missing from the Column State, the following rules apply:

- Attributes that are not supplied or are set to `undefined` will remain unchanged. For example if a Column has a Column State with just `pinned`, then Pinned is applied to that Column but other attributes, such as `sort` are left intact.
- When state is applied and there are additional Columns in the grid that do not appear in the provided state, then the `params.defaultState` is applied to those additional Columns.
- If `params.defaultState` is not provided, then any additional Columns in the grid will not be updated.

Combining these rules together allows flexible fine-grained state control. Take the following code snippets as examples:

```jsx
// Sort Athlete column ascending
gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ]
});

// Sort Athlete column ascending and clear sort on all other columns
gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ],
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting on all columns, leave all other attributes untouched
gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting, row group, pivot and pinned on all columns, leave all other attributes untouched
gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null,
        rowGroup: null,
        pivot: null,
        pinned: null
    }
});

// Order columns, but do nothing else
gridApi.applyColumnState({
    state: [
        { colId: 'athlete' },
        { colId: 'country' },
        { colId: 'age' },
        { colId: 'sport' }
    ],
    applyOrder: true
});
```

The example below shows some fine grained access to Column State.

#### Fine Grained State

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ColumnApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 150,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);
  const sideBar = useMemo<
    SideBarDef | string | string[] | boolean | null
  >(() => {
    return {
      toolPanels: ["columns"],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onBtSortAthlete = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [{ colId: "athlete", sort: "asc" }],
    });
  }, []);

  const onBtSortCountryThenSportClearOthers = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "country", sort: "asc", sortIndex: 0 },
        { colId: "sport", sort: "asc", sortIndex: 1 },
      ],
      defaultState: { sort: null },
    });
  }, []);

  const onBtClearAllSorting = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { sort: null },
    });
  }, []);

  const onBtRowGroupCountryThenSport = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "country", rowGroupIndex: 0 },
        { colId: "sport", rowGroupIndex: 1 },
      ],
      defaultState: { rowGroup: false },
    });
  }, []);

  const onBtRemoveCountryRowGroup = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [{ colId: "country", rowGroup: false }],
    });
  }, []);

  const onBtClearAllRowGroups = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { rowGroup: false },
    });
  }, []);

  const onBtOrderColsMedalsFirst = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
        { colId: "total" },
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "year" },
        { colId: "date" },
      ],
      applyOrder: true,
    });
  }, []);

  const onBtOrderColsMedalsLast = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "year" },
        { colId: "date" },
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
        { colId: "total" },
      ],
      applyOrder: true,
    });
  }, []);

  const onBtHideMedals = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "gold", hide: true },
        { colId: "silver", hide: true },
        { colId: "bronze", hide: true },
        { colId: "total", hide: true },
      ],
    });
  }, []);

  const onBtShowMedals = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "gold", hide: false },
        { colId: "silver", hide: false },
        { colId: "bronze", hide: false },
        { colId: "total", hide: false },
      ],
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <table>
              <tbody>
                <tr>
                  <td>Sort:</td>
                  <td>
                    <button onClick={onBtSortAthlete}>Sort Athlete</button>
                    <button onClick={onBtSortCountryThenSportClearOthers}>
                      Sort Country, then Sport - Clear Others
                    </button>
                    <button onClick={onBtClearAllSorting}>
                      Clear All Sorting
                    </button>
                  </td>
                </tr>
                <tr>
                  <td>Column Order:</td>
                  <td>
                    <button onClick={onBtOrderColsMedalsFirst}>
                      Show Medals First
                    </button>
                    <button onClick={onBtOrderColsMedalsLast}>
                      Show Medals Last
                    </button>
                  </td>
                </tr>
                <tr>
                  <td>Column Visibility:</td>
                  <td>
                    <button onClick={onBtHideMedals}>Hide Medals</button>
                    <button onClick={onBtShowMedals}>Show Medals</button>
                  </td>
                </tr>
                <tr>
                  <td>Row Group:</td>
                  <td>
                    <button onClick={onBtRowGroupCountryThenSport}>
                      Group Country then Sport
                    </button>
                    <button onClick={onBtRemoveCountryRowGroup}>
                      Remove Country
                    </button>
                    <button onClick={onBtClearAllRowGroups}>
                      Clear All Groups
                    </button>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              sideBar={sideBar}
              rowGroupPanelShow={"always"}
              pivotPanelShow={"always"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Fine Grained State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/fine-grained-state/reactFunctionalTs/)

### Saving Partial State

Using the techniques above, it is possible to save and restore a subset of the parameters in the state. The example below demonstrates this by selectively saving and restoring a) sort state, and b) column visibility and order state.

Note that when saving and restoring Sort state, other state attributes (width, row group, column order etc) are not impacted.

Likewise when saving and restoring visibility and order, only visibility and order will be impacted when re-applying the state.

#### Selective State

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
];

declare let window: any;

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 100,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 200,
    };
  }, []);
  const sideBar = useMemo<
    SideBarDef | string | string[] | boolean | null
  >(() => {
    return {
      toolPanels: ["columns"],
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onBtSaveSortState = useCallback(() => {
    const allState = gridRef.current!.api.getColumnState();
    const sortState = allState.map((state) => ({
      colId: state.colId,
      sort: state.sort,
      sortIndex: state.sortIndex,
    }));
    window.sortState = sortState;
    console.log("sort state saved", sortState);
  }, []);

  const onBtRestoreSortState = useCallback(() => {
    if (!window.sortState) {
      console.log("no sort state to restore, you must save sort state first");
      return;
    }
    gridRef.current!.api.applyColumnState({
      state: window.sortState,
    });
    console.log("sort state restored");
  }, [window]);

  const onBtSaveOrderAndVisibilityState = useCallback(() => {
    const allState = gridRef.current!.api.getColumnState();
    const orderAndVisibilityState = allState.map((state) => ({
      colId: state.colId,
      hide: state.hide,
    }));
    window.orderAndVisibilityState = orderAndVisibilityState;
    console.log("order and visibility state saved", orderAndVisibilityState);
  }, []);

  const onBtRestoreOrderAndVisibilityState = useCallback(() => {
    if (!window.orderAndVisibilityState) {
      console.log(
        "no order and visibility state to restore by, you must save order and visibility state first",
      );
      return;
    }
    gridRef.current!.api.applyColumnState({
      state: window.orderAndVisibilityState,
      applyOrder: true,
    });
    console.log("column state restored");
  }, [window]);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <div className="example-section">
              <button onClick={onBtSaveSortState}>Save Sort</button>
              <button onClick={onBtRestoreSortState}>Restore Sort</button>
              &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <button onClick={onBtSaveOrderAndVisibilityState}>
                Save Order &amp; Visibility
              </button>
              <button onClick={onBtRestoreOrderAndVisibilityState}>
                Restore Order &amp; Visibility
              </button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              sideBar={sideBar}
              rowGroupPanelShow={"always"}
              pivotPanelShow={"always"}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Selective State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/selective-state/reactFunctionalTs/)

## Considerations

There are a few items to note on specific state attributes. They are as follows:

### Column IDs

Column state is keyed by [Column ID](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-updating-definitions/#matching-columns), so give every column a `colId` or a `field` if you intend to save and re-apply its state. A column with neither is identified by its position in `columnDefs`, which means state saved before a reorder is re-applied to a different column. See [Grid State](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-state/#state-contents) for details.

### null vs undefined

For all state attributes, `undefined` means *"do not apply this attribute"* and `null` means *"clear this attribute"*.

For example setting `sort=null` will clear sort on a column whereas setting `sort=undefined` will leave whatever sort, if any, that is currently present.

The only exception is Column Width. Setting `null` is not supported because width is mandatory - there is no such thing as a Column with no width.

### Row Group and Pivot

There are two attributes representing both Row Group and Pivot. First using the boolean attributes `rowGroup` and `pivot` and then secondly using the index attributes `rowGroupIndex` and `pivotIndex`.

When `getColumnState()` is called, all of `rowGroup`, `pivot`, `rowGroupIndex` and `pivotIndex` are returned. When `applyColumnState()` is called, preference is given to the index variants. For example if both `rowGroup` and `rowGroupIndex` are present, `rowGroupIndex` is applied.

## Column Events

Column Events will get raised when applying a Column State as these events would normally get raised. For example `columnPinned` event will get raised if applying the state results in a column getting pinned or unpinned.

The example below demonstrates events getting raised based on Column State changes. The example logs event information to the console.

#### Column Events

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  Column,
  ColumnApiModule,
  ColumnMovedEvent,
  ColumnPinnedEvent,
  ColumnPivotChangedEvent,
  ColumnResizedEvent,
  ColumnRowGroupChangedEvent,
  ColumnValueChangedEvent,
  ColumnVisibleEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SortChangedEvent,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ColumnApiModule, ClientSideRowModelModule, PivotModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 150,
      enableRowGroup: true,
      enablePivot: true,
      enableValue: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onSortChanged = useCallback((e: SortChangedEvent) => {
    console.log("Event Sort Changed", e);
  }, []);

  const onColumnResized = useCallback((e: ColumnResizedEvent) => {
    console.log("Event Column Resized", e);
  }, []);

  const onColumnVisible = useCallback((e: ColumnVisibleEvent) => {
    console.log("Event Column Visible", e);
  }, []);

  const onColumnPivotChanged = useCallback((e: ColumnPivotChangedEvent) => {
    console.log("Event Pivot Changed", e);
  }, []);

  const onColumnRowGroupChanged = useCallback(
    (e: ColumnRowGroupChangedEvent) => {
      console.log("Event Row Group Changed", e);
    },
    [],
  );

  const onColumnValueChanged = useCallback((e: ColumnValueChangedEvent) => {
    console.log("Event Value Changed", e);
  }, []);

  const onColumnMoved = useCallback((e: ColumnMovedEvent) => {
    console.log("Event Column Moved", e);
  }, []);

  const onColumnPinned = useCallback((e: ColumnPinnedEvent) => {
    console.log("Event Column Pinned", e);
  }, []);

  const onBtSortOn = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "age", sort: "desc" },
        { colId: "athlete", sort: "asc" },
      ],
    });
  }, []);

  const onBtSortOff = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { sort: null },
    });
  }, []);

  const onBtWidthNarrow = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "age", width: 100 },
        { colId: "athlete", width: 100 },
      ],
    });
  }, []);

  const onBtWidthNormal = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "age", width: 200 },
        { colId: "athlete", width: 200 },
      ],
    });
  }, []);

  const onBtHide = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "age", hide: true },
        { colId: "athlete", hide: true },
      ],
    });
  }, []);

  const onBtShow = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { hide: false },
    });
  }, []);

  const onBtPivotOn = useCallback(() => {
    gridRef.current!.api.setGridOption("pivotMode", true);
    gridRef.current!.api.applyColumnState({
      state: [{ colId: "country", pivot: true }],
    });
  }, []);

  const onBtPivotOff = useCallback(() => {
    gridRef.current!.api.setGridOption("pivotMode", false);
    gridRef.current!.api.applyColumnState({
      defaultState: { pivot: false },
    });
  }, []);

  const onBtRowGroupOn = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [{ colId: "sport", rowGroup: true }],
    });
  }, []);

  const onBtRowGroupOff = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { rowGroup: false },
    });
  }, []);

  const onBtAggFuncOn = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "gold", aggFunc: "sum" },
        { colId: "silver", aggFunc: "sum" },
        { colId: "bronze", aggFunc: "sum" },
      ],
    });
  }, []);

  const onBtAggFuncOff = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { aggFunc: null },
    });
  }, []);

  const onBtNormalOrder = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
      ],
      applyOrder: true,
    });
  }, []);

  const onBtReverseOrder = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "bronze" },
        { colId: "silver" },
        { colId: "gold" },
      ],
      applyOrder: true,
    });
  }, []);

  const onBtPinnedOn = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      state: [
        { colId: "athlete", pinned: "left" },
        { colId: "sport", pinned: "right" },
      ],
    });
  }, []);

  const onBtPinnedOff = useCallback(() => {
    gridRef.current!.api.applyColumnState({
      defaultState: { pinned: null },
    });
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <div className="test-button-row">
              <div className="test-button-group">
                <button onClick={onBtSortOn}>Sort On</button>
                <br />
                <button onClick={onBtSortOff}>Sort Off</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtWidthNarrow}>Width Narrow</button>
                <br />
                <button onClick={onBtWidthNormal}>Width Normal</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtHide}>Hide Cols</button>
                <br />
                <button onClick={onBtShow}>Show Cols</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtReverseOrder}>Reverse Medal Order</button>
                <br />
                <button onClick={onBtNormalOrder}>Normal Medal Order</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtRowGroupOn}>Row Group On</button>
                <br />
                <button onClick={onBtRowGroupOff}>Row Group Off</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtAggFuncOn}>Agg Func On</button>
                <br />
                <button onClick={onBtAggFuncOff}>Agg Func Off</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtPivotOn}>Pivot On</button>
                <br />
                <button onClick={onBtPivotOff}>Pivot Off</button>
              </div>
              <div className="test-button-group">
                <button onClick={onBtPinnedOn}>Pinned On</button>
                <br />
                <button onClick={onBtPinnedOff}>Pinned Off</button>
              </div>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              onSortChanged={onSortChanged}
              onColumnResized={onColumnResized}
              onColumnVisible={onColumnVisible}
              onColumnPivotChanged={onColumnPivotChanged}
              onColumnRowGroupChanged={onColumnRowGroupChanged}
              onColumnValueChanged={onColumnValueChanged}
              onColumnMoved={onColumnMoved}
              onColumnPinned={onColumnPinned}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Column Events](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-events/reactFunctionalTs/)

## Column Group State

Column Group State is concerned with the state of Column Groups. There is only one state attribute for Column Groups, which is whether the group is open or closed.

To get the state of Column Groups use the API method `api.getColumnGroupState()`. To set the Column Group state use the API method `api.setColumnGroupState(stateItems)`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnGroupState` | `Function` |  |  |  |
| `setColumnGroupState` | `Function` |  |  |  |
| `resetColumnGroupState` | `Function` |  |  |  |

The example below demonstrates getting and setting Column Group State. Note the following:

- Clicking 'Save State' will save the opened / closed state of column groups.
- Clicking 'Restore State' will restore the previously saved state.
- Clicking 'Reset State' will reset the column state to match the Column Definitions, i.e. all Column Groups will be closed.

#### Column Group State

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule, RowGroupingModule];

declare let window: any;

const GridExample = () => {
  const gridRef = useRef<AgGridReact<IOlympicData>>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    {
      headerName: "Athlete",
      children: [
        { field: "athlete" },
        { field: "country", columnGroupShow: "open" },
        { field: "sport", columnGroupShow: "open" },
        { field: "year", columnGroupShow: "open" },
        { field: "date", columnGroupShow: "open" },
      ],
    },
    {
      headerName: "Medals",
      children: [
        { field: "total", columnGroupShow: "closed" },
        { field: "gold", columnGroupShow: "open" },
        { field: "silver", columnGroupShow: "open" },
        { field: "bronze", columnGroupShow: "open" },
      ],
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      width: 150,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const saveState = useCallback(() => {
    window.groupState = gridRef.current!.api.getColumnGroupState();
    console.log("group state saved", window.groupState);
    console.log("column group state saved");
  }, [window]);

  const restoreState = useCallback(() => {
    if (!window.groupState) {
      console.log("no columns state to restore by, you must save state first");
      return;
    }
    gridRef.current!.api.setColumnGroupState(window.groupState);
    console.log("column group state restored");
  }, [window]);

  const resetState = useCallback(() => {
    gridRef.current!.api.resetColumnGroupState();
    console.log("column group state reset");
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="test-container">
          <div className="test-header">
            <div className="example-section">
              Column State:
              <button onClick={saveState}>Save State</button>
              <button onClick={restoreState}>Restore State</button>
              <button onClick={resetState}>Reset State</button>
            </div>
          </div>

          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Column Group State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-group-state/reactFunctionalTs/)


---
product: "AG Grid"
title: "Column State"
description: "The full list of stateful attributes of Columns are represented by the ColumnStateParams interface:"
framework: angular
version: "36.2.0"
related:
    - title: "Column Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-definitions/"
    - title: "Updating Definitions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-updating-definitions/"
    - title: "Auto-Generate Columns"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/auto-generate-columns/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Column State

Column Definitions contain both stateful and non-stateful attributes. Stateful attributes can have their values changed by the grid (e.g. Column sort can be changed by the user clicking on the column header). Non-stateful attributes do not change from what is set in the Column Definition (e.g. once the Field is set as part of a Column Definition, it does not change).

> **Note**
>
> The DOM also has stateful vs non-stateful attributes. For example consider a DOM element and setting `element.style.width="100px"` will indefinitely set width to 100 pixels, the browser will not change this value. However setting `element.scrollTop=200` will set the scroll position, but the browser can change the scroll position further following user interaction, thus scroll position is stateful as the browser can change the state.

The full list of stateful attributes of Columns are represented by the `ColumnStateParams` interface:

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `hide` | `boolean \| null` |  |  |  |
| `width` | `number \| null` |  |  |  |
| `flex` | `number \| null` |  |  |  |
| `sort` | `SortDirection` |  |  |  |
| `sortType` | `SortType \| null` |  |  |  |
| `sortIndex` | `number \| null` |  |  |  |
| `aggFunc` | `string \| IAggFunc \| null` |  |  |  |
| `valueIndex` | `number \| null` |  |  |  |
| `pivot` | `boolean \| null` |  |  |  |
| `pivotIndex` | `number \| null` |  |  |  |
| `pivotSort` | `SortDirection` |  |  |  |
| `pinned` | `ColumnPinnedType` |  |  |  |
| `rowGroup` | `boolean \| null` |  |  |  |
| `rowGroupIndex` | `number \| null` |  |  |  |
| `showValuesAs` | `ShowValuesAsStateValue` |  |  |  |
| `headerName` | `string \| null` |  |  |  |

This section details how such state items can be manipulated without having to update Column Definitions.

## Save and Apply State

> **Note**
>
> If you want to save and restore the whole grid rather than manipulate individual column attributes, consider [Grid State](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/) instead. It contains all of the Column State properties alongside the other grid state sections — including [Calculated Columns](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/calculated-columns/) added at runtime, which Column State alone cannot recreate — and can be applied on initialisation via `initialState` or at runtime via `api.setState()`.

There are two API methods provided for getting and setting Column State. `api.getColumnState()` gets the current column state and `api.applyColumnState(params)` sets the column state.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnState` | `Function` |  |  |  |
| `applyColumnState` | `Function` |  |  |  |
| `resetColumnState` | `Function` |  |  |  |

The example below demonstrates saving and restoring column state. Try the following:

1. Click 'Save State' to save the Column State.
2. Change some column state, e.g. resize columns, move columns around, apply column sorting or row grouping, or rename an [editable header](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-headers/#editable-header-name) from its column menu, etc.
3. Click 'Restore State' and the column state is set back to where it was when you clicked 'Save State'.
4. Click 'Reset State' and the state will go back to what was defined in the Column Definitions.

#### Save and Apply State

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnHeaderEditModule,
  ColumnMenuModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnHeaderEditModule,
  ColumnMenuModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);
import { IOlympicData } from "./interfaces";

declare let window: any;

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <div class="example-section">
        <button (click)="saveState()">Save State</button>
        <button (click)="restoreState()">Restore State</button>
        <button (click)="resetState()">Reset State</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [sideBar]="sideBar"
      [rowGroupPanelShow]="rowGroupPanelShow"
      [pivotPanelShow]="pivotPanelShow"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete", headerNameEditable: true },
    { field: "age", headerNameEditable: true },
    { field: "country", headerNameEditable: true },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    width: 100,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: ["columns"],
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  pivotPanelShow: "always" | "onlyWhenPivoting" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  saveState() {
    window.colState = this.gridApi.getColumnState();
    console.log("column state saved");
  }

  restoreState() {
    if (!window.colState) {
      console.log("no columns state to restore by, you must save state first");
      return;
    }
    this.gridApi.applyColumnState({
      state: window.colState,
      applyOrder: true,
    });
    console.log("column state restored");
  }

  resetState() {
    this.gridApi.resetColumnState();
    console.log("column state reset");
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Save and Apply State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/save-apply-state/angular/)

## Partial State

It is possible to focus on particular columns and / or particular attributes when getting and / or applying a Column State. This allows fine grained control over the Column State, e.g. setting what Columns are Pinned, without impacting any other state attribute.

### Applying Partial State

When applying a Column State, in cases where some state attributes or columns are missing from the Column State, the following rules apply:

- Attributes that are not supplied or are set to `undefined` will remain unchanged. For example if a Column has a Column State with just `pinned`, then Pinned is applied to that Column but other attributes, such as `sort` are left intact.
- When state is applied and there are additional Columns in the grid that do not appear in the provided state, then the `params.defaultState` is applied to those additional Columns.
- If `params.defaultState` is not provided, then any additional Columns in the grid will not be updated.

Combining these rules together allows flexible fine-grained state control. Take the following code snippets as examples:

```ts
// Sort Athlete column ascending
this.gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ]
});

// Sort Athlete column ascending and clear sort on all other columns
this.gridApi.applyColumnState({
    state: [
        {
            colId: 'athlete',
            sort: 'asc'
        }
    ],
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting on all columns, leave all other attributes untouched
this.gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null
    }
});

// Clear sorting, row group, pivot and pinned on all columns, leave all other attributes untouched
this.gridApi.applyColumnState({
    defaultState: {
        // important to say 'null' as undefined means 'do nothing'
        sort: null,
        rowGroup: null,
        pivot: null,
        pinned: null
    }
});

// Order columns, but do nothing else
this.gridApi.applyColumnState({
    state: [
        { colId: 'athlete' },
        { colId: 'country' },
        { colId: 'age' },
        { colId: 'sport' }
    ],
    applyOrder: true
});
```

The example below shows some fine grained access to Column State.

#### Fine Grained State

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <table>
        <tbody>
          <tr>
            <td>Sort:</td>
            <td>
              <button (click)="onBtSortAthlete()">Sort Athlete</button>
              <button (click)="onBtSortCountryThenSportClearOthers()">
                Sort Country, then Sport - Clear Others
              </button>
              <button (click)="onBtClearAllSorting()">Clear All Sorting</button>
            </td>
          </tr>
          <tr>
            <td>Column Order:</td>
            <td>
              <button (click)="onBtOrderColsMedalsFirst()">
                Show Medals First
              </button>
              <button (click)="onBtOrderColsMedalsLast()">
                Show Medals Last
              </button>
            </td>
          </tr>
          <tr>
            <td>Column Visibility:</td>
            <td>
              <button (click)="onBtHideMedals()">Hide Medals</button>
              <button (click)="onBtShowMedals()">Show Medals</button>
            </td>
          </tr>
          <tr>
            <td>Row Group:</td>
            <td>
              <button (click)="onBtRowGroupCountryThenSport()">
                Group Country then Sport
              </button>
              <button (click)="onBtRemoveCountryRowGroup()">
                Remove Country
              </button>
              <button (click)="onBtClearAllRowGroups()">
                Clear All Groups
              </button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [sideBar]="sideBar"
      [rowGroupPanelShow]="rowGroupPanelShow"
      [pivotPanelShow]="pivotPanelShow"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    width: 150,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: ["columns"],
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  pivotPanelShow: "always" | "onlyWhenPivoting" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtSortAthlete() {
    this.gridApi.applyColumnState({
      state: [{ colId: "athlete", sort: "asc" }],
    });
  }

  onBtSortCountryThenSportClearOthers() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "country", sort: "asc", sortIndex: 0 },
        { colId: "sport", sort: "asc", sortIndex: 1 },
      ],
      defaultState: { sort: null },
    });
  }

  onBtClearAllSorting() {
    this.gridApi.applyColumnState({
      defaultState: { sort: null },
    });
  }

  onBtRowGroupCountryThenSport() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "country", rowGroupIndex: 0 },
        { colId: "sport", rowGroupIndex: 1 },
      ],
      defaultState: { rowGroup: false },
    });
  }

  onBtRemoveCountryRowGroup() {
    this.gridApi.applyColumnState({
      state: [{ colId: "country", rowGroup: false }],
    });
  }

  onBtClearAllRowGroups() {
    this.gridApi.applyColumnState({
      defaultState: { rowGroup: false },
    });
  }

  onBtOrderColsMedalsFirst() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
        { colId: "total" },
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "year" },
        { colId: "date" },
      ],
      applyOrder: true,
    });
  }

  onBtOrderColsMedalsLast() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "year" },
        { colId: "date" },
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
        { colId: "total" },
      ],
      applyOrder: true,
    });
  }

  onBtHideMedals() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "gold", hide: true },
        { colId: "silver", hide: true },
        { colId: "bronze", hide: true },
        { colId: "total", hide: true },
      ],
    });
  }

  onBtShowMedals() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "gold", hide: false },
        { colId: "silver", hide: false },
        { colId: "bronze", hide: false },
        { colId: "total", hide: false },
      ],
    });
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Fine Grained State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/fine-grained-state/angular/)

### Saving Partial State

Using the techniques above, it is possible to save and restore a subset of the parameters in the state. The example below demonstrates this by selectively saving and restoring a) sort state, and b) column visibility and order state.

Note that when saving and restoring Sort state, other state attributes (width, row group, column order etc) are not impacted.

Likewise when saving and restoring visibility and order, only visibility and order will be impacted when re-applying the state.

#### Selective State

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SideBarDef,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  PivotModule,
  RowGroupingPanelModule,
  ColumnApiModule,
]);
import { IOlympicData } from "./interfaces";

declare let window: any;

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <div class="example-section">
        <button (click)="onBtSaveSortState()">Save Sort</button>
        <button (click)="onBtRestoreSortState()">Restore Sort</button>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <button (click)="onBtSaveOrderAndVisibilityState()">
          Save Order &amp; Visibility
        </button>
        <button (click)="onBtRestoreOrderAndVisibilityState()">
          Restore Order &amp; Visibility
        </button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [sideBar]="sideBar"
      [rowGroupPanelShow]="rowGroupPanelShow"
      [pivotPanelShow]="pivotPanelShow"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "date" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
    { field: "total" },
  ];
  defaultColDef: ColDef = {
    width: 100,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 200,
  };
  sideBar: SideBarDef | string | string[] | boolean | null = {
    toolPanels: ["columns"],
  };
  rowGroupPanelShow: "always" | "onlyWhenGrouping" | "never" = "always";
  pivotPanelShow: "always" | "onlyWhenPivoting" | "never" = "always";
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onBtSaveSortState() {
    const allState = this.gridApi.getColumnState();
    const sortState = allState.map((state) => ({
      colId: state.colId,
      sort: state.sort,
      sortIndex: state.sortIndex,
    }));
    window.sortState = sortState;
    console.log("sort state saved", sortState);
  }

  onBtRestoreSortState() {
    if (!window.sortState) {
      console.log("no sort state to restore, you must save sort state first");
      return;
    }
    this.gridApi.applyColumnState({
      state: window.sortState,
    });
    console.log("sort state restored");
  }

  onBtSaveOrderAndVisibilityState() {
    const allState = this.gridApi.getColumnState();
    const orderAndVisibilityState = allState.map((state) => ({
      colId: state.colId,
      hide: state.hide,
    }));
    window.orderAndVisibilityState = orderAndVisibilityState;
    console.log("order and visibility state saved", orderAndVisibilityState);
  }

  onBtRestoreOrderAndVisibilityState() {
    if (!window.orderAndVisibilityState) {
      console.log(
        "no order and visibility state to restore by, you must save order and visibility state first",
      );
      return;
    }
    this.gridApi.applyColumnState({
      state: window.orderAndVisibilityState,
      applyOrder: true,
    });
    console.log("column state restored");
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Selective State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/selective-state/angular/)

## Considerations

There are a few items to note on specific state attributes. They are as follows:

### Column IDs

Column state is keyed by [Column ID](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-updating-definitions/#matching-columns), so give every column a `colId` or a `field` if you intend to save and re-apply its state. A column with neither is identified by its position in `columnDefs`, which means state saved before a reorder is re-applied to a different column. See [Grid State](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-state/#state-contents) for details.

### null vs undefined

For all state attributes, `undefined` means *"do not apply this attribute"* and `null` means *"clear this attribute"*.

For example setting `sort=null` will clear sort on a column whereas setting `sort=undefined` will leave whatever sort, if any, that is currently present.

The only exception is Column Width. Setting `null` is not supported because width is mandatory - there is no such thing as a Column with no width.

### Row Group and Pivot

There are two attributes representing both Row Group and Pivot. First using the boolean attributes `rowGroup` and `pivot` and then secondly using the index attributes `rowGroupIndex` and `pivotIndex`.

When `getColumnState()` is called, all of `rowGroup`, `pivot`, `rowGroupIndex` and `pivotIndex` are returned. When `applyColumnState()` is called, preference is given to the index variants. For example if both `rowGroup` and `rowGroupIndex` are present, `rowGroupIndex` is applied.

## Column Events

Column Events will get raised when applying a Column State as these events would normally get raised. For example `columnPinned` event will get raised if applying the state results in a column getting pinned or unpinned.

The example below demonstrates events getting raised based on Column State changes. The example logs event information to the console.

#### Column Events

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  Column,
  ColumnApiModule,
  ColumnMovedEvent,
  ColumnPinnedEvent,
  ColumnPivotChangedEvent,
  ColumnResizedEvent,
  ColumnRowGroupChangedEvent,
  ColumnValueChangedEvent,
  ColumnVisibleEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SortChangedEvent,
  enableDevValidations,
} from "ag-grid-community";
import { PivotModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnApiModule,
  ClientSideRowModelModule,
  PivotModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <div class="test-button-row">
        <div class="test-button-group">
          <button (click)="onBtSortOn()">Sort On</button>
          <br />
          <button (click)="onBtSortOff()">Sort Off</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtWidthNarrow()">Width Narrow</button>
          <br />
          <button (click)="onBtWidthNormal()">Width Normal</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtHide()">Hide Cols</button>
          <br />
          <button (click)="onBtShow()">Show Cols</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtReverseOrder()">Reverse Medal Order</button>
          <br />
          <button (click)="onBtNormalOrder()">Normal Medal Order</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtRowGroupOn()">Row Group On</button>
          <br />
          <button (click)="onBtRowGroupOff()">Row Group Off</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtAggFuncOn()">Agg Func On</button>
          <br />
          <button (click)="onBtAggFuncOff()">Agg Func Off</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtPivotOn()">Pivot On</button>
          <br />
          <button (click)="onBtPivotOff()">Pivot Off</button>
        </div>
        <div class="test-button-group">
          <button (click)="onBtPinnedOn()">Pinned On</button>
          <br />
          <button (click)="onBtPinnedOff()">Pinned Off</button>
        </div>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      (sortChanged)="onSortChanged($event)"
      (columnResized)="onColumnResized($event)"
      (columnVisible)="onColumnVisible($event)"
      (columnPivotChanged)="onColumnPivotChanged($event)"
      (columnRowGroupChanged)="onColumnRowGroupChanged($event)"
      (columnValueChanged)="onColumnValueChanged($event)"
      (columnMoved)="onColumnMoved($event)"
      (columnPinned)="onColumnPinned($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "age" },
    { field: "country" },
    { field: "sport" },
    { field: "gold" },
    { field: "silver" },
    { field: "bronze" },
  ];
  defaultColDef: ColDef = {
    width: 150,
    enableRowGroup: true,
    enablePivot: true,
    enableValue: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onSortChanged(e: SortChangedEvent) {
    console.log("Event Sort Changed", e);
  }

  onColumnResized(e: ColumnResizedEvent) {
    console.log("Event Column Resized", e);
  }

  onColumnVisible(e: ColumnVisibleEvent) {
    console.log("Event Column Visible", e);
  }

  onColumnPivotChanged(e: ColumnPivotChangedEvent) {
    console.log("Event Pivot Changed", e);
  }

  onColumnRowGroupChanged(e: ColumnRowGroupChangedEvent) {
    console.log("Event Row Group Changed", e);
  }

  onColumnValueChanged(e: ColumnValueChangedEvent) {
    console.log("Event Value Changed", e);
  }

  onColumnMoved(e: ColumnMovedEvent) {
    console.log("Event Column Moved", e);
  }

  onColumnPinned(e: ColumnPinnedEvent) {
    console.log("Event Column Pinned", e);
  }

  onBtSortOn() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "age", sort: "desc" },
        { colId: "athlete", sort: "asc" },
      ],
    });
  }

  onBtSortOff() {
    this.gridApi.applyColumnState({
      defaultState: { sort: null },
    });
  }

  onBtWidthNarrow() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "age", width: 100 },
        { colId: "athlete", width: 100 },
      ],
    });
  }

  onBtWidthNormal() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "age", width: 200 },
        { colId: "athlete", width: 200 },
      ],
    });
  }

  onBtHide() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "age", hide: true },
        { colId: "athlete", hide: true },
      ],
    });
  }

  onBtShow() {
    this.gridApi.applyColumnState({
      defaultState: { hide: false },
    });
  }

  onBtPivotOn() {
    this.gridApi.setGridOption("pivotMode", true);
    this.gridApi.applyColumnState({
      state: [{ colId: "country", pivot: true }],
    });
  }

  onBtPivotOff() {
    this.gridApi.setGridOption("pivotMode", false);
    this.gridApi.applyColumnState({
      defaultState: { pivot: false },
    });
  }

  onBtRowGroupOn() {
    this.gridApi.applyColumnState({
      state: [{ colId: "sport", rowGroup: true }],
    });
  }

  onBtRowGroupOff() {
    this.gridApi.applyColumnState({
      defaultState: { rowGroup: false },
    });
  }

  onBtAggFuncOn() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "gold", aggFunc: "sum" },
        { colId: "silver", aggFunc: "sum" },
        { colId: "bronze", aggFunc: "sum" },
      ],
    });
  }

  onBtAggFuncOff() {
    this.gridApi.applyColumnState({
      defaultState: { aggFunc: null },
    });
  }

  onBtNormalOrder() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "gold" },
        { colId: "silver" },
        { colId: "bronze" },
      ],
      applyOrder: true,
    });
  }

  onBtReverseOrder() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "athlete" },
        { colId: "age" },
        { colId: "country" },
        { colId: "sport" },
        { colId: "bronze" },
        { colId: "silver" },
        { colId: "gold" },
      ],
      applyOrder: true,
    });
  }

  onBtPinnedOn() {
    this.gridApi.applyColumnState({
      state: [
        { colId: "athlete", pinned: "left" },
        { colId: "sport", pinned: "right" },
      ],
    });
  }

  onBtPinnedOff() {
    this.gridApi.applyColumnState({
      defaultState: { pinned: null },
    });
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Column Events](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-events/angular/)

## Column Group State

Column Group State is concerned with the state of Column Groups. There is only one state attribute for Column Groups, which is whether the group is open or closed.

To get the state of Column Groups use the API method `api.getColumnGroupState()`. To set the Column Group state use the API method `api.setColumnGroupState(stateItems)`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getColumnGroupState` | `Function` |  |  |  |
| `setColumnGroupState` | `Function` |  |  |  |
| `resetColumnGroupState` | `Function` |  |  |  |

The example below demonstrates getting and setting Column Group State. Note the following:

- Clicking 'Save State' will save the opened / closed state of column groups.
- Clicking 'Restore State' will restore the previously saved state.
- Clicking 'Reset State' will reset the column state to match the Column Definitions, i.e. all Column Groups will be closed.

#### Column Group State

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule, RowGroupingModule]);
import { IOlympicData } from "./interfaces";

declare let window: any;

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-container">
    <div class="test-header">
      <div class="example-section">
        Column State:
        <button (click)="saveState()">Save State</button>
        <button (click)="restoreState()">Restore State</button>
        <button (click)="resetState()">Reset State</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi<IOlympicData>;

  columnDefs: (ColDef | ColGroupDef)[] = [
    {
      headerName: "Athlete",
      children: [
        { field: "athlete" },
        { field: "country", columnGroupShow: "open" },
        { field: "sport", columnGroupShow: "open" },
        { field: "year", columnGroupShow: "open" },
        { field: "date", columnGroupShow: "open" },
      ],
    },
    {
      headerName: "Medals",
      children: [
        { field: "total", columnGroupShow: "closed" },
        { field: "gold", columnGroupShow: "open" },
        { field: "silver", columnGroupShow: "open" },
        { field: "bronze", columnGroupShow: "open" },
      ],
    },
  ];
  defaultColDef: ColDef = {
    width: 150,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  saveState() {
    window.groupState = this.gridApi.getColumnGroupState();
    console.log("group state saved", window.groupState);
    console.log("column group state saved");
  }

  restoreState() {
    if (!window.groupState) {
      console.log("no columns state to restore by, you must save state first");
      return;
    }
    this.gridApi.setColumnGroupState(window.groupState);
    console.log("column group state restored");
  }

  resetState() {
    this.gridApi.resetColumnGroupState();
    console.log("column group state reset");
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.gridApi = params.api;

    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Column Group State](https://www.ag-grid.com/archive/36.2.0/examples/column-state/column-group-state/angular/)
